#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <winioctl.h>
#include <conio.h>
#include <stddef.h>
#include "wdgioctl.h"        // This defines the IOCTL constants.

void watchdog(HANDLE *);            // Open the Device only
void watchdog_refresh(HANDLE);      // refresh the device again
void disable_watchdog(HANDLE);      // disable the device and Close it
void watchdog_control(HANDLE, int); // Output one command to device

void __cdecl main()
{
    HANDLE  hFile;          // Handle to device, obtain from CreateFile
    int     DoWork=1;       // Command Input from Keyboard
	int     getChar;

	hFile = INVALID_HANDLE_VALUE;
    printf("Input the Command : ( [Q]uit to Exit ) \n");
    printf("   WatchDog [E]nable [D]isable [R]efresh\n");
    printf("   Remote Power Control of[F]   o[N]\n");
    while ( DoWork ) {
        if ( _kbhit() ) {
			getChar = _getch();
            if ( hFile == INVALID_HANDLE_VALUE ) {
                if ( getChar == (int)'Q' || getChar == (int)'q' ) {
                    DoWork = 0;
                    break;
                }
                if ( getChar == (int)'E' || getChar == (int)'e' ) {
                    watchdog(&hFile);
                    if (hFile == INVALID_HANDLE_VALUE)
                        printf("Watchdog Device can not open\n");
                    else {
                        printf("Watchdog Device is opened\n");
                        watchdog_refresh(hFile);
                    }
				} else {
					printf("Enable WatchDog Adapter First !!");
				}
			} else
	        switch ( getChar ) {
		        case ('Q'):
		        case ('q'): DoWork=0; break;
                case ('D'):
                case ('d'): disable_watchdog(hFile); 
                            hFile = INVALID_HANDLE_VALUE; break;
		        case ('R'):
		        case ('r'): watchdog_refresh(hFile); break;
		        case ('F'):
		        case ('f'): watchdog_control(hFile, 1); break;
		        case ('N'):
		        case ('n'): watchdog_control(hFile, 0); break;
                default : printf("  Press Wrong Key !!"); break;
	        }
	        printf("\r");
        }
    }
    disable_watchdog(hFile);
}


void watchdog(HANDLE *phFile)
{
    *phFile = CreateFile("\\\\.\\WdgDev",      // Open the Device "file"
             GENERIC_READ | GENERIC_WRITE , 
             FILE_SHARE_READ,
             NULL, 
             OPEN_EXISTING, 
             0,   
             NULL);
}

void watchdog_refresh(HANDLE hFile)
{
    // The following parameters are used in the IOCTL call
    ULONG   PortNumber;      // Buffer sent to the driver (Port #).
    union   {
        ULONG   LongData;
        USHORT  ShortData;
        UCHAR   CharData;
    } DataBuffer;            // Buffer received from driver (Data).
    LONG    IoctlCode;
    ULONG   DataLength;
    DWORD   ReturnedLength;  // Number of bytes returned

    IoctlCode = IOCTL_GPD_READ_PORT_UCHAR;
    DataLength = sizeof(DataBuffer.CharData);
    PortNumber = 0; // For port 0 : Enable(Refresh), port 1 : Disable
    if ( DeviceIoControl(
                    hFile,            // Handle to device
                    IoctlCode,          // IO Control code for Read
                    &PortNumber,        // Buffer to driver.
                    sizeof(PortNumber), // Length of buffer in bytes.
                    &DataBuffer,        // Buffer from driver.
                    DataLength,         // Length of buffer in bytes.
                    &ReturnedLength,    // Bytes placed in DataBuffer.
                    NULL )              // NULL means wait till completes.
                    ) 
         printf("WatchDog is Refreshed        ");
    else printf("Watchdog Operation failed with code %ld\n", GetLastError());
}

void disable_watchdog(HANDLE hFile)
{
    ULONG   PortNumber;      // Buffer sent to the driver (Port #).
    union   {
        ULONG   LongData;
        USHORT  ShortData;
        UCHAR   CharData;
    } DataBuffer;            // Buffer received from driver (Data).
    LONG    IoctlCode;
    ULONG   DataLength;
    DWORD   ReturnedLength;  // Number of bytes returned

	if( hFile == INVALID_HANDLE_VALUE) return;
    IoctlCode = IOCTL_GPD_READ_PORT_UCHAR;
    DataLength = sizeof(DataBuffer.CharData);
    PortNumber = 1; // For port 0 : Enable(Refresh), port 1 : Disable
    if ( DeviceIoControl(
                    hFile,            // Handle to device
                    IoctlCode,          // IO Control code for Read
                    &PortNumber,        // Buffer to driver.
                    sizeof(PortNumber), // Length of buffer in bytes.
                    &DataBuffer,        // Buffer from driver.
                    DataLength,         // Length of buffer in bytes.
                    &ReturnedLength,    // Bytes placed in DataBuffer.
                    NULL )              // NULL means wait till completes.
                    ) 
         printf("WatchDog is Refreshed        ");
    else printf("Watchdog Operation failed with code %ld\n", GetLastError());
    CloseHandle(hFile);
    printf("Watchdog is closed\n");
}

void watchdog_control(HANDLE hFile, int Value)
{
    GENPORT_WRITE_INPUT InputBuffer;    // Input buffer for DeviceIoControl
    LONG                IoctlCode;
    ULONG               DataLength;
    ULONG               ReturnedLength; // Number of bytes returned in output buffer

	if( hFile == INVALID_HANDLE_VALUE) return;
    IoctlCode = IOCTL_GPD_WRITE_PORT_UCHAR;
    InputBuffer.CharData = (UCHAR)Value;      // Set Value
    InputBuffer.PortNumber = 1;               // Select Port Number
    DataLength = offsetof(GENPORT_WRITE_INPUT, CharData) +
                         sizeof(InputBuffer.CharData);
    if ( DeviceIoControl(
        hFile,                  // Handle to device
        IoctlCode,              // IO Control code for Write
        &InputBuffer,           // Buffer to driver.  Holds port & data.
        DataLength,             // Length of buffer in bytes.
        NULL,                   // Buffer from driver.   Not used.
        0,                      // Length of buffer in bytes.
        &ReturnedLength,        // Bytes placed in outbuf.  Should be 0.
        NULL )                  // NULL means wait till I/O completes.
        )
         printf("Remote Command was sent        ");
    else printf("Watchdog Operation failed with code %ld\n", GetLastError());
}
